diff --git a/drivers/gpu/drm/nouveau/include/nvkm/subdev/therm.h b/drivers/gpu/drm/nouveau/include/nvkm/subdev/therm.h
index b268b96..0e2574d 100644
--- a/drivers/gpu/drm/nouveau/include/nvkm/subdev/therm.h
+++ b/drivers/gpu/drm/nouveau/include/nvkm/subdev/therm.h
@@ -89,11 +89,13 @@ struct nvkm_therm {
 int nvkm_therm_temp_get(struct nvkm_therm *);
 int nvkm_therm_fan_sense(struct nvkm_therm *);
 int nvkm_therm_cstate(struct nvkm_therm *, int, int);
+void nvkm_therm_clkgate_engine(struct nvkm_therm *, enum nvkm_devidx, bool);
 
 int nv40_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
 int nv50_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
 int g84_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
 int gt215_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
+int gf100_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
 int gf119_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
 int gm107_therm_new(struct nvkm_device *, int, struct nvkm_therm **);
 #endif
diff --git a/drivers/gpu/drm/nouveau/nvkm/core/engine.c b/drivers/gpu/drm/nouveau/nvkm/core/engine.c
index b6c9169..e3d52c1 100644
--- a/drivers/gpu/drm/nouveau/nvkm/core/engine.c
+++ b/drivers/gpu/drm/nouveau/nvkm/core/engine.c
@@ -26,6 +26,7 @@
 #include <core/option.h>
 
 #include <subdev/fb.h>
+#include <subdev/therm.h>
 
 bool
 nvkm_engine_chsw_load(struct nvkm_engine *engine)
@@ -86,6 +87,9 @@ static int
 nvkm_engine_fini(struct nvkm_subdev *subdev, bool suspend)
 {
 	struct nvkm_engine *engine = nvkm_engine(subdev);
+
+	nvkm_therm_clkgate_engine(subdev->device->therm, subdev->index, true);
+
 	if (engine->func->fini)
 		return engine->func->fini(engine, suspend);
 	return 0;
@@ -96,12 +100,13 @@ nvkm_engine_init(struct nvkm_subdev *subdev)
 {
 	struct nvkm_engine *engine = nvkm_engine(subdev);
 	struct nvkm_fb *fb = subdev->device->fb;
+	struct nvkm_therm *therm = subdev->device->therm;
 	int ret = 0, i;
 	s64 time;
 
 	if (!engine->usecount) {
 		nvkm_trace(subdev, "init skipped, engine has no users\n");
-		return ret;
+		goto finish;
 	}
 
 	if (engine->func->oneinit && !engine->subdev.oneinit) {
@@ -123,6 +128,11 @@ nvkm_engine_init(struct nvkm_subdev *subdev)
 
 	for (i = 0; fb && i < fb->tile.regions; i++)
 		nvkm_engine_tile(engine, i);
+
+finish:
+	if (!ret)
+		nvkm_therm_clkgate_engine(therm, subdev->index, true);
+
 	return ret;
 }
 
diff --git a/drivers/gpu/drm/nouveau/nvkm/engine/device/base.c b/drivers/gpu/drm/nouveau/nvkm/engine/device/base.c
index b690bc1..d133016 100644
--- a/drivers/gpu/drm/nouveau/nvkm/engine/device/base.c
+++ b/drivers/gpu/drm/nouveau/nvkm/engine/device/base.c
@@ -1355,7 +1355,7 @@ nvc0_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf100_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
@@ -1392,7 +1392,7 @@ nvc1_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf106_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
@@ -1428,7 +1428,7 @@ nvc3_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf106_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
@@ -1464,7 +1464,7 @@ nvc4_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf100_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
@@ -1501,7 +1501,7 @@ nvc8_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf100_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
@@ -1538,7 +1538,7 @@ nvce_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf100_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
@@ -1575,7 +1575,7 @@ nvcf_chipset = {
 	.mxm = nv50_mxm_new,
 	.pci = gf106_pci_new,
 	.pmu = gf100_pmu_new,
-	.therm = gt215_therm_new,
+	.therm = gf100_therm_new,
 	.timer = nv41_timer_new,
 	.volt = gf100_volt_new,
 	.ce[0] = gf100_ce_new,
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/Kbuild b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/Kbuild
index 135758b..cbb9465 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/Kbuild
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/Kbuild
@@ -1,4 +1,5 @@
 nvkm-y += nvkm/subdev/therm/base.o
+nvkm-y += nvkm/subdev/therm/clkgate.o
 nvkm-y += nvkm/subdev/therm/fan.o
 nvkm-y += nvkm/subdev/therm/fannil.o
 nvkm-y += nvkm/subdev/therm/fanpwm.o
@@ -9,5 +10,6 @@ nvkm-y += nvkm/subdev/therm/nv40.o
 nvkm-y += nvkm/subdev/therm/nv50.o
 nvkm-y += nvkm/subdev/therm/g84.o
 nvkm-y += nvkm/subdev/therm/gt215.o
+nvkm-y += nvkm/subdev/therm/gf100.o
 nvkm-y += nvkm/subdev/therm/gf119.o
 nvkm-y += nvkm/subdev/therm/gm107.o
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/clkgate.c b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/clkgate.c
new file mode 100644
index 0000000..48494d0
--- /dev/null
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/clkgate.c
@@ -0,0 +1,32 @@
+/*
+ * Copyright 2017 Red Hat Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE COPYRIGHT HOLDER(S) OR AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
+ * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ *
+ * Authors: Lyude Paul
+ */
+#include "priv.h"
+
+void
+nvkm_therm_clkgate_engine(struct nvkm_therm *therm, enum nvkm_devidx engine,
+			  bool enable)
+{
+	if (therm->func->clkgate_engine)
+		therm->func->clkgate_engine(therm, engine, enable);
+}
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf100.c b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf100.c
new file mode 100644
index 0000000..c31bd2c
--- /dev/null
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf100.c
@@ -0,0 +1,81 @@
+/*
+ * Copyright 2017 Red Hat Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE COPYRIGHT HOLDER(S) OR AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
+ * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ *
+ * Authors: Lyude Paul
+ */
+#include <core/device.h>
+
+#include "priv.h"
+
+static inline int
+gf100_clkgate_engine_offset(enum nvkm_devidx subdev)
+{
+	switch (subdev) {
+		case NVKM_ENGINE_GR:     return 0x00;
+		case NVKM_ENGINE_MSPDEC: return 0x04;
+		case NVKM_ENGINE_MSPPP:  return 0x08;
+		case NVKM_ENGINE_MSVLD:  return 0x0c;
+		case NVKM_ENGINE_CE0:    return 0x10;
+		case NVKM_ENGINE_CE1:    return 0x14;
+		case NVKM_ENGINE_MSENC:  return 0x18;
+		case NVKM_ENGINE_CE2:    return 0x1c;
+		default:                 return -1;
+	}
+}
+
+void
+gf100_clkgate_engine(struct nvkm_therm *therm, enum nvkm_devidx subdev,
+		     bool enable)
+{
+	int offset = gf100_clkgate_engine_offset(subdev);
+	u8 data;
+
+	if (offset == -1)
+		return;
+
+	if (enable) /* ENG_CLK=auto, BLK_CLK=auto, ENG_PWR=run, BLK_PWR=auto */
+		data = 0x45;
+	else        /* ENG_CLK=run, BLK_CLK=auto, ENG_PWR=run, BLK_PWR=auto*/
+		data = 0x44;
+
+	nvkm_mask(therm->subdev.device, 0x20200 + offset, 0xff, data);
+}
+
+static const struct nvkm_therm_func
+gf100_therm = {
+	.init = gt215_therm_init,
+	.fini = g84_therm_fini,
+	.pwm_ctrl = nv50_fan_pwm_ctrl,
+	.pwm_get = nv50_fan_pwm_get,
+	.pwm_set = nv50_fan_pwm_set,
+	.pwm_clock = nv50_fan_pwm_clock,
+	.temp_get = g84_temp_get,
+	.fan_sense = gt215_therm_fan_sense,
+	.program_alarms = nvkm_therm_program_alarms_polling,
+	.clkgate_engine = gf100_clkgate_engine,
+};
+
+int
+gf100_therm_new(struct nvkm_device *device, int index,
+		struct nvkm_therm **ptherm)
+{
+	return nvkm_therm_new_(&gf100_therm, device, index, ptherm);
+}
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf119.c b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf119.c
index 06dcfd6..568dffa 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf119.c
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gf119.c
@@ -143,6 +143,7 @@ gf119_therm = {
 	.temp_get = g84_temp_get,
 	.fan_sense = gt215_therm_fan_sense,
 	.program_alarms = nvkm_therm_program_alarms_polling,
+	.clkgate_engine = gf100_clkgate_engine,
 };
 
 int
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gm107.c b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gm107.c
index 86848ec..afc4ff6 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gm107.c
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gm107.c
@@ -65,6 +65,7 @@ gm107_therm = {
 	.temp_get = g84_temp_get,
 	.fan_sense = gt215_therm_fan_sense,
 	.program_alarms = nvkm_therm_program_alarms_polling,
+	.clkgate_engine = gf100_clkgate_engine,
 };
 
 int
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gt215.c b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gt215.c
index c08097f..4caf401 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gt215.c
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/gt215.c
@@ -36,7 +36,7 @@ gt215_therm_fan_sense(struct nvkm_therm *therm)
 	return -ENODEV;
 }
 
-static void
+void
 gt215_therm_init(struct nvkm_therm *therm)
 {
 	struct nvkm_device *device = therm->subdev.device;
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/priv.h b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/priv.h
index 235a5d8..32d9bce 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/therm/priv.h
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/therm/priv.h
@@ -96,6 +96,8 @@ struct nvkm_therm_func {
 	int (*fan_sense)(struct nvkm_therm *);
 
 	void (*program_alarms)(struct nvkm_therm *);
+
+	void (*clkgate_engine)(struct nvkm_therm *, enum nvkm_devidx, bool);
 };
 
 void nv40_therm_intr(struct nvkm_therm *);
@@ -110,6 +112,9 @@ void g84_sensor_setup(struct nvkm_therm *);
 void g84_therm_fini(struct nvkm_therm *);
 
 int gt215_therm_fan_sense(struct nvkm_therm *);
+void gt215_therm_init(struct nvkm_therm *);
+
+void gf100_clkgate_engine(struct nvkm_therm *, enum nvkm_devidx, bool);
 
 void gf119_therm_init(struct nvkm_therm *);
 